<?php

class SerwerSMS_Kontakty {

    //----------------------------------------------------------------------------------------------------------------------------------------//
    // uwaga, zaleca się utworzenie osobnego loginu i hasła do komunikacji przez WebAPI.
    // Nowego użytkownika HTTPS XML API można utworzyć z poziomu Panelu Klienta -> Wysyłka wiad. -> HTTPS XML API -> Użytkownicy HTTPS XML API
    //----------------------------------------------------------------------------------------------------------------------------------------//

    private static $API_URL = 'https://api1.serwersms.pl/zdalnie/';
    public static $Test = 0;
    
    public static $DaneKonta = array();
    public static $Nadawca = null;
    public static $NDI = null;
    public static $PotwierdzenieSMS = 'Twoj numer zostal poprawnie zapisany do bazy kontaktow.';
    public static $UsuniecieSMS = 'Twoj numer zostal poprawnie usuniety z bazy kontaktow';
    public static $KodSMS = 'Twoj kod potwiedzajacy to:';
    
    public function __construct($login, $haslo, $test = 0) {
        self::$DaneKonta['login'] = $login;
        self::$DaneKonta['haslo'] = $haslo;
        self::$Test = (int) $test;
    }
    
    public function setNadawca($nadawca){
        self::$Nadawca = $nadawca;
    }
    
    public function setNDI($ndi){
        self::$NDI = $ndi;
    }
    
    public function setPotwierdzenieSMS($potwierdzenie){
        self::$PotwierdzenieSMS = $potwierdzenie;
    }
    
    public function setUsuniecieSMS($usuwanie){
        self::$UsuniecieSMS = $usuwanie;
    }
    
    public function setTrescKodSMS($kodsms){
        self::$KodSMS = $kodsms;
    }

    private static function Zapytanie($akcja, $params) {

        $requestUrl = self::$API_URL;
        $params["akcja"] = $akcja;
        $params["test"] = self::$Test;
        $postParams = array_merge(self::$DaneKonta, $params);

        $curl = curl_init($requestUrl);

        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($postParams));
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_TIMEOUT, 30);
        $answer = curl_exec($curl);
        if (curl_errno($curl)) {
            die('<pre style="color:red">' . curl_error($curl) . ':' . curl_errno($curl) . '</pre>');
            exit();
        }
        curl_close($curl);

        return $answer;
    }

    private function xml_attribute($object, $attribute) {
        if (isset($object[$attribute]))
            return (string) $object[$attribute];
    }

    private function przetworzXML($akcja,$xml_file) {
        $dom = new domDocument;
        $dom->loadXML($xml_file);
        $xml = simplexml_import_dom($dom);

        if (isset($xml->Blad)) {
            $wynik = (string) $xml->Blad;
        }

        if($akcja=="wyslij_sms") {
		if(isset($xml->Odbiorcy->Skolejkowane)){	
                    $wynik = true;
                } else {
                    $wynik = false;
                }
	}
        
        if($akcja=="kontakty"){
            $wynik = array();
            if (isset($xml->GRUPA->KONTAKT)) { // lista kontaktów
                if (isset($xml->GRUPA->NAZWA)) {
                    $i = 0;
                    foreach($xml as $grupa){
                        $kontakty = array();
                        $j = 0;
                        foreach ($grupa->KONTAKT as $kontakt) {
                            if (isset($kontakt)) {
                                $kontakty[$j]['id'] = self::xml_attribute($kontakt, 'id');
                                $kontakty[$j]['telefon'] = (string) $kontakt->TELEFON;
                                $kontakty[$j]['email'] = (string) $kontakt->EMAIL;
                                $kontakty[$j]['firma'] = (string) $kontakt->FIRMA;
                                $kontakty[$j]['imie'] = (string) $kontakt->IMIE;
                                $kontakty[$j]['nazwisko'] = (string) $kontakt->NAZWISKO;
                                $j++;
                            }
                        }
                        $wynik[$i]['grupa'] = (string) $grupa->NAZWA;
                        $wynik[$i]['id'] = self::xml_attribute($grupa, 'id');
                        $wynik[$i]['ilosc'] = self::xml_attribute($grupa, 'ilosc');
                        $wynik[$i]['kontakty'] = $kontakty;
                        $i++;
                    }
                }

            } elseif (isset($xml->GRUPA->NAZWA)) { // lista grup
                $i = 0;
                foreach ($xml as $grupy) {
                    if (isset($grupy)) {
                        $wynik[$i]['nazwa'] = (string) $grupy->NAZWA;
                        $wynik[$i]['id'] = self::xml_attribute($grupy, 'id');
                        $wynik[$i]['ilosc'] = self::xml_attribute($grupy, 'ilosc');
                        $i++;
                    }
                }
            } elseif (isset($xml->GRUPA)) { // dodanie nowej grupy / usuwanie grupy
                $wynik['id'] = self::xml_attribute($xml->GRUPA, 'id');
                $wynik['stan'] = (string) $xml->GRUPA;
            } elseif (isset($xml->KONTAKT)) { // dodanie nowego kontaktu do grupy / usuwanie kontaktu
                $wynik['id'] = self::xml_attribute($xml->KONTAKT, 'id');
                $wynik['stan'] = (string) $xml->KONTAKT;
            }
        }
        
        if($akcja=="numery_dostepowe") {
            $xml = simplexml_load_string($xml_file);
            foreach($xml as $x) {
               if($x=="OK") $wynik = true;
               else $wynik = false;
            }
	}
        return $wynik;
    }
    
    private static function wyslijKodSMS($numer,$kod){
        return self::wyslijSMS($numer,self::$KodSMS.' '.$kod);
    }

    private static function kontakty($Parametry) {
        return self::Zapytanie("kontakty", $Parametry);
    }
    
    private static function numerDostepowy($Parametry) {
        return self::Zapytanie("numery_dostepowe", $Parametry);
    }
    
    public static function pobierzIdentyfikatory($numer,$grupa = null){
        $lista = self::listaKontaktow($numer,$grupa);
        $identyfikatory = array();

        foreach($lista as $grupa){
            foreach($grupa['kontakty'] as $kontakt){
                if(!in_array($kontakt['id'],$identyfikatory)){
                    $identyfikatory[] = $kontakt['id'];
                }
            }
        }
        return $identyfikatory;
    }
    
    public static function wyslijSMS($numer,$wiadomosc){
        $Parametry = array(
            'numer' => $numer,
            'wiadomosc' => $wiadomosc,
            'nadawca' => self::$Nadawca
        );
        $xml = self::Zapytanie("wyslij_sms", $Parametry);
        return self::przetworzXML("wyslij_sms",$xml);
    }
    
    public static function wyslijPotwierdzenieDopisania($numer){
        return self::wyslijSMS($numer,self::$PotwierdzenieSMS);
    }
    
    public static function wyslijPotwierdzenieUsuniecia($numer){
        return self::wyslijSMS($numer,self::$UsuniecieSMS);
    }
    
    public static function listaGrup(){
        $xml = self::kontakty(array('operacja' => "lista_grup"));
        return self::przetworzXML("kontakty",$xml);
    }
    
    public static function listaKontaktow($numer = null, $id_grupy = null){
        $xml = self::kontakty(array('operacja' => "lista_kontaktow", 'numer' => $numer, 'grupa' => $id_grupy));
        return self::przetworzXML("kontakty",$xml);
    }
    
    public static function dodajGrupe($nazwa){
        if(!empty($nazwa)){
            $xml = self::kontakty(array('operacja' => "dodaj_grupe", 'grupa' => $nazwa));
            return self::przetworzXML("kontakty",$xml);
        } else {
            return false;
        }
    }
    
    public static function dodajKontakt($grupy,$numer,$email = null,$imie = null,$nazwisko = null,$firma = null){
        if(!empty($numer) and !empty($grupy)){
            if(is_array($grupy)) $grupy = implode(",",$grupy);
            $id_grupy = addslashes(htmlspecialchars($grupy));
            $xml = self::kontakty(array('operacja' => "dodaj_kontakt", 'dane' => "$id_grupy:$numer:$email:$imie:$nazwisko:$firma"));
            return self::przetworzXML("kontakty",$xml);
        } else {
            return false;
        }
    }
    
    public static function usunGrupe($id_grupy){
        if(!empty($id_grupy)){
            $xml = self::kontakty(array('operacja' => "usun_grupe", 'grupa' => $id_grupy));
            $zwrot = self::przetworzXML("kontakty",$xml);
            if($zwrot['stan'] == 'OK'){
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
    
    public static function usunKontakt($id_kontaktu){
        if(!empty($id_kontaktu)){
            $xml = self::kontakty(array('operacja' => "usun_kontakt", 'kontakt' => $id_kontaktu));
            $zwrot = self::przetworzXML("kontakty",$xml);
            if($zwrot['stan'] == 'OK'){
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
    
    public static function usunNumer($numer){
        if(!empty($numer)){
            $wynik = true;
            $identyfikatory = self::pobierzIdentyfikatory($numer);
            
            foreach($identyfikatory as $id_kontaktu){
                $xml = self::kontakty(array('operacja' => "usun_kontakt", 'kontakt' => $id_kontaktu));
                $zwrot = self::przetworzXML("kontakty",$xml);
                if($zwrot['stan'] != 'OK'){
                    $wynik = false;
                }
            }
        } else {
            $wynik = false;
        }
        return $wynik;
    }
    
    public static function weryfikacjaSMS($numer){
        $kod = md5(time().rand(0,500));
        $_SESSION['kod'] = $kod;
        //setcookie("kod",$kod,time()+3600);
        $skrot = substr($kod,3,3).substr($kod,10,3);
        return self::wyslijKodSMS($numer,$skrot);
    }
    
    public static function sprawdzKod($kod){
//        if(isset($_COOKIE['kod'])){
//            $skrot = substr($_COOKIE['kod'],3,3).substr($_COOKIE['kod'],10,3);
//            if($skrot == $kod){
//                return true;
//            } else {
//                return false;
//            }
//        } else {
//            return false;
//        }
        if(isset($_SESSION['kod'])){
            $skrot = substr($_SESSION['kod'],3,3).substr($_SESSION['kod'],10,3);
            if($skrot == $kod){
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
    
    public static function przetworzPrzezND($numer,$haslo_dostepowe){
        if(isset(self::$NDI)){
            $parametry = array(
                'numer' => $numer,
                'ndi' => $haslo_dostepowe,
                'idndi' => self::$NDI
            );
        } else {
            $parametry = array(
                'numer' => $numer,
                'nd' => $haslo_dostepowe
            );
        }
        $xml = self::numerDostepowy($parametry);
        return self::przetworzXML("numery_dostepowe",$xml);
    }

}

?>
