<?php

/**
 * 
 * 1. Weryfikacja kodem SMS
 * 2. Wybór jednej grupy kontaktów
 * 3. Dodanie oraz usunięcie za pomocą hasła Numeru Dostępowego
 * 
 * --------------------------
 * Parametry do wprowadzenia:
 * 1. Login i hasło do SerwerSMS
 * 2. Numer Dostępowy Indywidualny
 * 
 */

session_start();

function czyscDane($string){
    return addslashes(htmlspecialchars(trim($string)));
}

require_once("SerwerSMS_Kontakty.class.php");

$SerwerSMS = new SerwerSMS_Kontakty("login","haslo");
// Wiadomość bez nazwy nadawcy (ECO)
//$SerwerSMS->setNadawca('INFORMACJA'); // Nagłówek nadawcy wiadomości SMS
$SerwerSMS->setPotwierdzenieSMS("To jest tresc smsa potwierdzajacego dopisanie do kontaktow"); // Treść SMS-a potwierdzającego dodanie numeru do kontaktów
$SerwerSMS->setTrescKodSMS("To jest tresc smsa z kodem potwierdzajacym. Twoj kod to:"); // Treść wiadomości z kodem weryfikującym numer
$SerwerSMS->setNDI('+48000000000'); // Ustawienie Numeru Dostępowego Indywidualnego

$weryfikacja = null;
$wynik = null;

if(isset($_POST['numer'])){
    $numer = czyscDane($_POST['numer']);
    $_SESSION['numer'] = $numer;
    $_SESSION['grupa'] = (int) $_POST['grupa'];
    $_SESSION['wybor'] = (int) $_POST['wybor'];
    $sms = $SerwerSMS->weryfikacjaSMS($numer);
    if($sms){
        $weryfikacja = 1;
    } else {
        $weryfikacja = 0;
    }
} else if(isset($_POST['kodsms'])){
    $kodsms = czyscDane($_POST['kodsms']);
    if($SerwerSMS->sprawdzKod($kodsms)){
        if($wybor == 2){
            $haslo = 'USUN';
        } else {
            switch($_SESSION['grupa']){
                case 1: $haslo = 'WARSZAWA'; break;
                case 2: $haslo = 'KATOWICE'; break;
                case 3: $haslo = 'GDANSK'; break;
                default: $haslo = 'BRAK'; break;
            }
        }
        
        $wyslij = $SerwerSMS->przetworzPrzezND($_SESSION['numer'],$haslo);
        if($wyslij){
            $wynik = 1;
        }
        
        unset($_SESSION);
        session_destroy();
    } else {
        $wynik = 2;
        $weryfikacja = 1;
    }
} else {
    $wynik = 4;
}

?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
    <head>
        <title>SerwerSMS Kontakty - Przykład 2</title>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    </head>
    <body>
        <p>
            <?php
            switch ($wynik) {
                case 1:
                    echo '<span style="color: green">Operacja zakończona powodzeniem. Za chwilę otrzymasz SMS z potwierdzeniem</span>';
                    break;
                case 2:
                    echo '<span style="color: red">Wpisany kod jest niepoprawny. Spróbuj ponownie</span>';
                    break;
            }
            ?>
        </p>

        <?php
        if (!isset($weryfikacja) or $weryfikacja != '1') {
        ?>

            <form method="post">
                <label for="numer">Numer telefonu komórkowego: </label>
                <input type="text" name="numer" id="numer" />
                <br />
                <input type="radio" name="wybor" id="zapisz" value="1" checked="checked" />
                <label for="zapisz">Zapisz</label>
                <input type="radio" name="wybor" id="wypisz" value="2" />
                <label for="wypisz">Wypisz</label>

            <ul>
                <li>
                    <input type="radio" name="grupa" value="1" id="grupa1" />
                    <label for="grupa1">Warszawa</label>
                </li>
                <li>
                    <input type="radio" name="grupa" value="2" id="grupa2" />
                    <label for="grupa2">Katowice</label>
                </li>
                <li>
                    <input type="radio" name="grupa" value="3" id="grupa3" />
                    <label for="grupa3">Gdańsk</label>
                </li>
            </ul>
            <input type="submit" value="Wyślij zgłoszenie" />
        </form>

    <?php
    } else { // ELSE
        ?>
        <form method="post">
            <label for="kodsms">Potwierdzający kod SMS*:</label>
            <input type="text" name="kodsms" id="kodsms" />

            <br />
                <input type="submit" value="Potwierdź" />

        </form>
        <?php
    } // END IF
    ?>
</body>
</html>