<?php
/**
 * 
 * 1. Weryfikacja kodem SMS
 * 2. Dodanie lub usunięcie numeru z bazy
 * 3. Wprowadzenie numeru z dodatkowymi danymi (imię, nazwisko, e-mail)
 * 4. Wybór kilku grup kontaktów jednocześnie
 * 5. Wysyłka SMS-a potwierdzającego dodanie oraz usunięcie numeru
 * 
 * --------------------------
 * Parametry do wprowadzenia:
 * 1. Login i hasło do SerwerSMS
 * 2. Identyfikatory grup (do pobrania z Panelu Klienta, po wybraniu edycji danej grupy)
 * 
 */
session_start();

function czyscDane($string) {
    return addslashes(htmlspecialchars(trim($string)));
}

require_once("SerwerSMS_Kontakty.class.php");

$SerwerSMS = new SerwerSMS_Kontakty("login", "haslo");
$SerwerSMS->setNadawca('INFORMACJA'); // Nagłówek nadawcy wiadomości SMS
$SerwerSMS->setPotwierdzenieSMS("To jest tresc smsa potwierdzajacego dopisanie do kontaktow"); // Treść SMS-a potwierdzającego dodanie numeru do kontaktów
$SerwerSMS->setUsuniecieSMS("To jest tresc smsa potwierdzajacego usunieie numeru z kontaktow"); // Tresć SMS-a potwierdzającego usunięcie numeru z kontaktów
$SerwerSMS->setTrescKodSMS("To jest tresc smsa z kodem potwierdzajacym. Twoj kod to:"); // Treść wiadomości z kodem weryfikującym numer

$weryfikacja = null;
$wynik = null;

if (isset($_POST['numer'])) {
    $numer = czyscDane($_POST['numer']);
    $_SESSION['numer'] = $numer;
    $_SESSION['email'] = czyscDane($_POST['email']);
    $_SESSION['imie'] = czyscDane($_POST['imie']);
    $_SESSION['nazwisko'] = czyscDane($_POST['nazwisko']);
    $_SESSION['grupa'] = $_POST['grupa'];
    $_SESSION['wybor'] = (int) $_POST['wybor'];
    $sms = $SerwerSMS->weryfikacjaSMS($numer);
    if ($sms) {
        $weryfikacja = 1;
    } else {
        $weryfikacja = 0;
    }
} else if (isset($_POST['kodsms'])) {
    $kodsms = czyscDane($_POST['kodsms']);
    if ($SerwerSMS->sprawdzKod($kodsms)) {
        if ($_SESSION['wybor'] == 2) {
            $blad = false;
            foreach ($_SESSION['grupa'] as $id_grupy) {
                $identyfikatory[] = $SerwerSMS->pobierzIdentyfikatory($_SESSION['numer'], $id_grupy);
            }

            foreach ($identyfikatory as $kontakt) {
                foreach($kontakt as $id_kontaktu){
                    $usun = $SerwerSMS->usunKontakt($id_kontaktu);
                    if (!$usun) {
                        $blad = true;
                    }
                }
            }
            //$usun = $SerwerSMS->usunNumer($_SESSION['numer']);
            if (!$blad) {
                $SerwerSMS->wyslijPotwierdzenieUsuniecia($_SESSION['numer']);
                $wynik = 3;
            }
        } else {
            $blad = false;
            foreach ($_SESSION['grupa'] as $id_grupy) {
                $dodaj = $SerwerSMS->dodajKontakt($id_grupy, $_SESSION['numer'], $_SESSION['email'], $_SESSION['imie'], $_SESSION['nazwisko']);
                if ($dodaj['stan'] != 'OK') {
                    $blad = true;
                }
            }
            if (!$blad) {
                $SerwerSMS->wyslijPotwierdzenieDopisania($_SESSION['numer']);
                $wynik = 1;
            }
        }
        unset($_SESSION);
        session_destroy();
    } else {
        $wynik = 2;
        $weryfikacja = 1;
    }
} else {
    $wynik = 4;
}
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
    <head>
        <title>SerwerSMS Kontakty - Przykład 3</title>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    </head>
    <body>
        <p>
<?php
switch ($wynik) {
    case 1:
        echo '<span style="color: green">Twój numer został poprawnie dodany do bazy. Za chwilę otrzymasz SMS z potwierdzeniem</span>';
        break;
    case 2:
        echo '<span style="color: red">Wpisany kod jest niepoprawny. Spróbuj ponownie</span>';
        break;
    case 3:
        echo '<span style="color: green">Numer został poprawnie usunięty. Za chwilę otrzymasz SMS z potwierdzeniem</font>';
        break;
}
?>
        </p>

            <?php
            if (!isset($weryfikacja) or $weryfikacja != '1') {
                ?>

            <form method="post">
                <label for="imie">Imię:</label>
                <input type="text" name="imie" id="imie" />
                <br />
                <label for="nazwisko">Nazwisko:</label>
                <input type="text" name="nazwisko" id="nazwisko" />
                <br />
                <label for="numer">Numer telefonu komórkowego: </label>
                <input type="text" name="numer" id="numer" />
                <br />
                <label for="email">Adres e-mail: </label>
                <input type="text" name="email" id="email" />
                <br />
                <input type="radio" name="wybor" id="zapisz" value="1" checked="checked" />
                <label for="zapisz">Zapisz</label>
                <input type="radio" name="wybor" id="wypisz" value="2" />
                <label for="wypisz">Wypisz</label>

                <ul>
                    <li>
                        <input type="checkbox" name="grupa[]" value="00000001" id="grupa1" />
                        <label for="grupa1">Grupa 1</label>
                    </li>
                    <li>
                        <input type="checkbox" name="grupa[]" value="00000002" id="grupa2" />
                        <label for="grupa2">Grupa 2</label>
                    </li>
                    <li>
                        <input type="checkbox" name="grupa[]" value="00000003" id="grupa3" />
                        <label for="grupa3">Grupa 3</label>
                    </li>
                </ul>
                <input type="submit" value="Wyślij zgłoszenie" />
            </form>

    <?php
} else { // ELSE
    ?>
            <form method="post">
                <label for="kodsms">Potwierdzający kod SMS*:</label>
                <input type="text" name="kodsms" id="kodsms" />

                <br />
                <input type="submit" value="Potwierdź" />

            </form>
    <?php
} // END IF
?>
    </body>
</html>